"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tapable_1 = require("tapable");
const plugins_1 = require("@sewing-kit/plugins");
const PLUGIN = 'SewingKit.babel';
const addBabelHooks = plugins_1.addHooks(() => ({
    babelConfig: new tapable_1.AsyncSeriesWaterfallHook(['babelConfig']),
    babelIgnorePatterns: new tapable_1.AsyncSeriesWaterfallHook([
        'babelIgnorePatterns',
    ]),
}));
const addPackageBabelHooks = plugins_1.addHooks(() => ({
    babelConfig: new tapable_1.AsyncSeriesWaterfallHook(['babelConfig']),
    babelIgnorePatterns: new tapable_1.AsyncSeriesWaterfallHook([
        'babelIgnorePatterns',
    ]),
    babelExtensions: new tapable_1.AsyncSeriesWaterfallHook([
        'extensions',
    ]),
}));
exports.babelProjectPlugin = plugins_1.createProjectPlugin({
    id: PLUGIN,
    run({ build, test, dev }) {
        build.tap(PLUGIN, ({ hooks }) => {
            hooks.package.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addPackageBabelHooks);
            });
            hooks.webApp.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
            hooks.service.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
        });
        dev.tap(PLUGIN, ({ hooks }) => {
            hooks.package.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
            hooks.webApp.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
            hooks.service.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
        });
        test.tap(PLUGIN, ({ hooks }) => {
            hooks.project.tap(PLUGIN, ({ hooks }) => {
                hooks.configure.tap(PLUGIN, addBabelHooks);
            });
        });
    },
});
